<script setup lang="ts">
import { ref , shallowRef, watch} from "vue";
import searchConfig from "./config/search.config";
import contentConfig from "./config/content.config";

import { PageContentInstance } from "/@/components/PageContent";
import { useRenderIcon } from "/@/components/ReIcon/src/hooks";
import { usePageSearch, type PageHooks } from "/@/hooks/page";
import { isBeyondTime } from "/@/views/time/_utils";
import { httpRequsetExport } from "/@/utils/export";
import { usePermission } from "/@/hooks/core";
import { useUserStore } from "/@/store/modules/user";

const pageName = "goodSaleHot";
const { hasPermissionWithCode } = usePermission(pageName);
const pageContentRef = ref<PageContentInstance | null>(null);
const loading = shallowRef(false);

const userStore = useUserStore();
const searchConfigRef = ref(searchConfig);
const hooks: PageHooks = {
  pageSearchHook: () =>  usePageSearch(undefined, undefined, searchConfig)
};

const callback = {
  onSuccess: () => (loading.value = false),
  onStart: () => (loading.value = true),
  onFail: () => (loading.value = false)
};

watch(
  () => userStore.level,
  level => {
    const { formItems } = searchConfigRef.value;
    const index = formItems.findIndex(({ field }) => field === "depart_id");
    const { itemid = "" } = userStore.info || {};

    if (Number(level) === 2) {
      // searchConfigRef.value.formItems[index].disabled = Number(level) === 2;
      searchConfigRef.value.formItems[index].defaultValue = itemid;
    }
  },
  {
    immediate: true
  }
);



async function handleExportAllReport() {
  const params = pageContentRef.value.getBasicParams() || {};
  const { start_date, end_date } = params;
  const beyondTime = isBeyondTime({ start:start_date, end:end_date, len: 30 });

  if (beyondTime) return;

  await httpRequsetExport({
    params,
    ...callback,
    isAdmin: false,
    name: "产品热销排行榜.xlsx",
    fileType: "aplication/x-msexecl",
    url:"/purchease/sale/goodSaleHotListExport"
  });
}
</script>

<template>
  <page-auth :page-name="pageName">
    <page-container
      :hooks="hooks"
      :page-name="pageName"
      :get-content-ref="ref => (pageContentRef = ref)"
      :content-config="contentConfig"
      :search-config="searchConfig"
    >
      <template #content_header>
        <el-button
          v-if="hasPermissionWithCode('9')"
          @click="handleExportAllReport"
          size="small"
          :icon="useRenderIcon('arrow-up-line')"
          type="primary"
          >导出</el-button
        >
      </template>
    </page-container>
  </page-auth>
</template>
